var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from "react";
import App from "_/src/entry";

var tabPattern = "/~/";
var currentPage = "$$currentPage";
var df = "default";

var PageProxy = function (_Component) {
    _inherits(PageProxy, _Component);

    function PageProxy() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, PageProxy);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PageProxy.__proto__ || Object.getPrototypeOf(PageProxy)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(PageProxy, [{
        key: "getPagePath",
        value: function getPagePath(props) {
            var _ref2 = props || this.props,
                url = _ref2.match.url;

            var path = url.substr(1) || "home";
            return path.split(tabPattern);
        }
    }, {
        key: "componentWillMount",
        value: function componentWillMount() {
            this.loadAsyncPages(this.getPagePath());
        }
    }, {
        key: "isPathChange",
        value: function isPathChange(path1, path2) {
            var l1 = path1.length;
            var l2 = path2.length;
            if (l1 !== l2) {
                return true;
            } else {
                var i = void 0;
                for (i = 0; i < l1.length; i++) {
                    if (l1[i] !== l2[i]) {
                        return true;
                    }
                }
            }
            return false;
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            var currentPath = this.getPagePath();
            var nextPath = this.getPagePath(nextProps);
            if (currentPath, nextPath) {
                this.loadAsyncPages(nextPath);
            }
        }
    }, {
        key: "renderTabElement",
        value: function renderTabElement(tabPaths, pagePath) {
            var _this2 = this;

            var tabArray = this.getTabPathArray(tabPaths, pagePath);
            return tabArray.reduceRight(function (element, oneTabPath) {
                var TabClass = _this2.state[oneTabPath];
                if (!TabClass) {
                    return null;
                }
                var tabName = oneTabPath.split('/').pop();
                if (element) {
                    return React.cloneElement(React.createElement(TabClass, { _tabName: tabName }), null, element);
                } else {
                    return React.createElement(TabClass, { _tabName: tabName });
                }
            }, null);
        }
    }, {
        key: "renderPageElement",
        value: function renderPageElement() {
            var state = this.state;

            var _getPagePath = this.getPagePath(),
                _getPagePath2 = _slicedToArray(_getPagePath, 2),
                pagePath = _getPagePath2[0],
                tabPath = _getPagePath2[1];

            var PageComponent = state[pagePath];
            var pageElement = !!PageComponent ? React.createElement(PageComponent, this.props) : React.createElement(
                "div",
                null,
                "loading..."
            );
            var tabElement = null;
            if (tabPath) {
                tabElement = this.renderTabElement(tabPath, pagePath);
            }
            return React.cloneElement(pageElement, {}, tabElement);
        }
    }, {
        key: "render",
        value: function render() {
            var pageElement = this.renderPageElement();
            return React.createElement(
                App,
                this.props,
                pageElement
            );
        }
    }, {
        key: "getTabPathArray",
        value: function getTabPathArray() {
            var tabPath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
            var pagePath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

            var tabArray = [];
            var tempTabRecord = "";
            tabPath.split("/").forEach(function (item, index) {
                tempTabRecord += index === 0 ? item : "/" + item;
                tabArray.push(pagePath + "/" + tempTabRecord);
            });
            return tabArray;
        }
    }, {
        key: "warn",
        value: function warn(msg) {
            console && console.error && console.error(msg);
        }
    }, {
        key: "loadAsyncPages",
        value: function loadAsyncPages(path) {
            var _this3 = this;

            var pagePath = path[0];
            var tabPath = path[1];
            var loadTabs = [],
                tabsArray = tabPath ? this.getTabPathArray(tabPath, pagePath) : [],
                loadPage = this.state[pagePath] ? false : import( /* webpackMode: "lazy", webpackChunkName: "[request]" */"_/src/pages/" + pagePath + "/page-view");
            if (tabPath) {
                loadTabs = tabsArray.map(function (item) {
                    if (!_this3.state[item]) {
                        return import( /* webpackMode: "lazy-once", webpackChunkName: "tabs" */"_/src/pages/" + item + "/tab-view");
                    } else {
                        return _this3.state[item];
                    }
                });
            }
            Promise.all([loadPage]).then(function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 1),
                    PageComponent = _ref4[0];

                var needUpdate = false;
                var updateData = {};
                if (PageComponent) {
                    needUpdate = true;
                    updateData[pagePath] = PageComponent[df];
                }
                if (_this3.state[currentPage] !== pagePath) {
                    needUpdate = true;
                    updateData[currentPage] = pagePath;
                }
                if (needUpdate) {
                    _this3.setState(updateData);
                }
                Promise.all(loadTabs).then(function (tabViews) {
                    tabViews.forEach(function (tabview, index) {
                        var tabPath = tabsArray[index];
                        if (!_this3.state[tabPath]) {
                            _this3.setState(_defineProperty({}, tabPath, tabview[df]));
                        }
                    });
                }).catch(function (err) {
                    _this3.warn("\u4F60\u73B0\u5728\u6B63\u5728\u8BF7\u6C42\uFF1A" + pagePath + " \u9875\u9762\u4E0B\u7684Tab " + tabPath + "\uFF0C\u8BF7\u786E\u8BA4\u4F60\u7684\u8DEF\u5F84\u5199\u5BF9\u4E86\uFF0C\u6216\u8005\u68C0\u67E5\u8FD9\u4E2A\u7EC4\u4EF6\u4F60\u505A\u4E86\u6CA1");
                });
            }).catch(function (err) {
                _this3.warn("\u9875\u9762 " + pagePath + " \u6CA1\u6709\u627E\u5230\uFF0C\u8BF7\u786E\u8BA4\u4F60\u7684\u8DEF\u5F84\u662F\u5426\u5199\u5BF9\u4E86\u3002");
            });
        }
    }]);

    return PageProxy;
}(Component);

export default PageProxy;